-- displayFunctions
--
-- Author RivalBomb

displayFunctions = {};
function displayFunctions.prerequisitesPresent(specializations)
    return true;
end;

function displayFunctions:load(xmlFile)
	self.playStartUpAnimation = SpecializationUtil.callSpecializationsFunction("playStartUpAnimation");


	self.displayFunctions = {};
	
	local key = "vehicle.displayFunctions.";
	
	self.displayFunctions.preHeating = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."preHeating#index"));
	self.displayFunctions.battery = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."battery#index"));
	self.displayFunctions.handbrake = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."handbrake#index"));
	self.displayFunctions.handbrakehebel = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."handbrakehebel#index"));
	
	self.displayFunctions.allrad = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."allrad#index"));
	self.displayFunctions.allradhebel = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."allradhebel#index"));
	self.displayFunctions.diffvorne = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."diffvorne#index"));
	self.displayFunctions.diffvorne1 = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."diffvorne1#index"));
	self.displayFunctions.diffhinten = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."diffhinten#index"));
	self.displayFunctions.schalterfront = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "schalterfront#index"));	
	self.displayFunctions.diffhebel = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."diffhebel#index"));
	
	self.displayFunctions.ptoan = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "ptoan#index"));	
	self.displayFunctions.ptoan1 = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "ptoan1#index"));
	self.displayFunctions.ptoan2 = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "ptoan2#index"));
	self.displayFunctions.schalterptoback = Utils.indexToObject(self.components, getXMLString(xmlFile, key.. "schalterptoback#index"));	
	setVisibility(self.displayFunctions.ptoan,false);
    setVisibility(self.displayFunctions.ptoan1,false);
	setVisibility(self.displayFunctions.ptoan2,false);
	
	self.startUpAnimation = getXMLString(xmlFile, "vehicle.startUpAnimation#name");
	self.firstrun = false;
	self.mFlickeringS = 0;
end;

function displayFunctions:delete()
	if self.displayFunctions.piepSound ~= nil and self.isClient then
		Utils.deleteSample(self.displayFunctions.piepSound);
	end;
end;

function displayFunctions:mouseEvent(posX, posY, isDown, isUp, button)
end;

function displayFunctions:keyEvent(unicode, sym, modifier, isDown)
end;

function displayFunctions:update(dt)
	--Handbremse
		if self.displayFunctions.handbrake ~= nil then
			if g_currentMission.driveControl ~= nil and g_currentMission.driveControl.useModules ~= nil and g_currentMission.driveControl.useModules.handBrake ~= nil and g_currentMission.driveControl.useModules.handBrake and self.driveControl ~= nil and self.driveControl.handBrake ~= nil and self.driveControl.handBrake.isActive ~= nil then
				if self.driveControl.handBrake.isActive then
					setVisibility(self.displayFunctions.handbrake, true);
					setRotation(self.displayFunctions.handbrakehebel, Utils.degToRad(0), 0, 0 );
				else
					setVisibility(self.displayFunctions.handbrake, false);
					setRotation(self.displayFunctions.handbrakehebel, Utils.degToRad(52), 0, 0 )
				end;
			end;
		
	-- Allrad und Diffrentiale	
		if self.driveControl ~= nil and self.driveControl.fourWDandDifferentials ~= nil then
			if self.driveControl.fourWDandDifferentials.fourWheel then
			setVisibility(self.displayFunctions.allrad, true);
			setRotation(self.displayFunctions.allradhebel, Utils.degToRad(0), 0, 0 );
		else
			setVisibility(self.displayFunctions.allrad, false);
			setRotation(self.displayFunctions.allradhebel, Utils.degToRad(90), 0, 0 );
		end;
			if self.driveControl.fourWDandDifferentials.diffLockFront then
			setVisibility(self.displayFunctions.diffvorne, true);
			setVisibility(self.displayFunctions.diffvorne1, true);
			setRotation(self.displayFunctions.schalterfront, Utils.degToRad(0), 0, 0 );
		else
			setVisibility(self.displayFunctions.diffvorne, false);
			setVisibility(self.displayFunctions.diffvorne1, false);
			setRotation(self.displayFunctions.schalterfront, Utils.degToRad(20), 0, 0 );
		end;
			if self.driveControl.fourWDandDifferentials.diffLockBack then
			setVisibility(self.displayFunctions.diffhinten, true);
			setRotation(self.displayFunctions.diffhebel, Utils.degToRad(0), 0, 0 );
		else
			setVisibility(self.displayFunctions.diffhinten, false);
			setRotation(self.displayFunctions.diffhebel, Utils.degToRad(90), 0, 0 );
		end;         
	end;

	-- PTO vorne
		for i=1, table.getn(self.attachedImplements) do
            local implement = self.attachedImplements[i];
            if implement.jointDescIndex == 2 then
                if implement.object ~= nil and implement.object.getIsPowerTakeoffActive ~= nil then
                    setVisibility(self.displayFunctions.ptoan1,implement.object:getIsPowerTakeoffActive());
                end;
            end;
        end;
        
	--PTO hinten
		for i=1, table.getn(self.attachedImplements) do
            local implement = self.attachedImplements[i];
            if implement.jointDescIndex == 4 then
                if implement.object ~= nil and implement.object.getIsPowerTakeoffActive ~= nil then
                    setVisibility(self.displayFunctions.ptoan,implement.object:getIsPowerTakeoffActive());
					setVisibility(self.displayFunctions.ptoan2,implement.object:getIsPowerTakeoffActive());
				end;
            end;
        end;
		
		for i=1, table.getn(self.attachedImplements) do
            local implement = self.attachedImplements[i];
            if implement.jointDescIndex == 1 then
                if implement.object ~= nil and implement.object.getIsPowerTakeoffActive ~= nil then
                    setVisibility(self.displayFunctions.ptoan,implement.object:getIsPowerTakeoffActive());
					setVisibility(self.displayFunctions.ptoan2,implement.object:getIsPowerTakeoffActive());
				end;
            end;
        end;
	
	-- preHeating --
		if (self.ignitionMode ~= nil and self.ignitionMode == ManualIgnition.STAGE_PRE_HEAT) or (self.driveControl ~=nil and self.driveControl.manMotorStart.isMotorStarted ~= nil and self.driveControl.manMotorStart.isMotorStarted == false and self.driveControl.manMotorStart.startCnt ~= nil and self.driveControl.manMotorStart.startCnt < 800 and self.driveControl.manMotorStart.startCnt > 0) then 
			self.displayFunctions.t=self.displayFunctions.t+dt;
			if self.displayFunctions.preHeating ~= nil then
				if self.displayFunctions.t <= 2000 then
					setVisibility(self.displayFunctions.preHeating, true);
				else
					setVisibility(self.displayFunctions.preHeating, false);
				end;
			end;
			if self.displayFunctions.battery ~= nil then
				setVisibility(self.displayFunctions.battery, true);
			end;
			
			if self.displayFunctions.piepSound ~= nil and self.isClient then
				if not Utils.isSamplePlaying(self.displayFunctions.piepSound) then
					Utils.playSample(self.displayFunctions.piepSound,0,1,nil);
				end;
			end;
			if self.startUpAnimation ~= nil and self.playAnimation ~= nil and not self.firstrun then
				self:playStartUpAnimation(1);
			end;
			self.firstrun = true;
		else
			self.firstrun = false;
			if self.displayFunctions.piepSound ~= nil and self.isClient then
				if Utils.isSamplePlaying(self.displayFunctions.piepSound) then
					Utils.stopSample(self.displayFunctions.piepSound, true);
				end;
			end;
			if self.displayFunctions.preHeating ~= nil then
				setVisibility(self.displayFunctions.preHeating, false);
				self.displayFunctions.t=0;
			end;
			if self.displayFunctions.battery ~= nil then
				setVisibility(self.displayFunctions.battery, false);
			end;
		end;
		if (self.ignitionMode ~= nil and not self.ignitionMode == ManualIgnition.STAGE_OFF) or (self.driveControl ~=nil and self.driveControl.manMotorStart.isMotorStarted ~= nil and not self.driveControl.manMotorStart.isMotorStarted) then
			if self.startUpAnimation ~= nil and self.playAnimation ~= nil and (self.animations[self.startUpAnimation].currentTime > 0) and not self.firstrun then
				self:playStartUpAnimation(-100);
			end;
		end;
	else
		if self.displayFunctions.piepSound ~= nil and self.isClient then
			if Utils.isSamplePlaying(self.displayFunctions.piepSound) then
				Utils.stopSample(self.displayFunctions.piepSound, true);
			end;
		end;
	end;
end;


function displayFunctions:draw()
end;

function displayFunctions:playStartUpAnimation(speed)
	self:playAnimation(self.startUpAnimation, speed, nil, true);
end;